from torch import nn

from model.LcT import LcT


def build_model(opts, config):
    model_type = config.MODEL.TYPE

    if model_type == 'lct':
        model = LcT(num_classes=config.MODEL.NUM_CLASSES,
                    drop_rate=config.MODEL.DROP_RATE,
                    drop_path_rate=config.MODEL.DROP_PATH_RATE,
                    classifier_drop_rate=config.MODEL.CLASSIFIER_DROPOUT,

                    ffn_type=config.MODEL.LET.FFN_TYPE,
                    stem_type=config.MODEL.LET.STEM_TYPE,
                    heads_dim=config.MODEL.LET.HEADS_DIM,

                    ffn_ratio=config.MODEL.LET.FFN_RATIO,
                    irb_ratio=config.MODEL.LET.IRB_RATIO,
                    output_ratio=config.MODEL.LET.OUTPUT_RATIO,

                    window_size=config.MODEL.LET.WINDOW_SIZE,
                    kernel_size=config.MODEL.LET.KERNEL_SIZE,
                    ffn_kernel_size=config.MODEL.LET.FFN_KERNEL_SIZE,
                    depths=config.MODEL.LET.DEPTHS,

                    stem_channels=config.MODEL.LET.STEM_CHANNELS,
                    stage_channels=config.MODEL.LET.STAGE_CHANNELS,
                    transformer_dims=config.MODEL.LET.TRANSFORMER_DIMS,
                    qkv_bias=config.MODEL.LET.QKV_BIAS,
                    qk_scale=config.MODEL.LET.QK_SCALE,
                    use_checkpoint=config.TRAIN.USE_CHECKPOINT,
                    )

    else:
        raise print("failure to create model:" + opts.model_name)

    return model
